Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/SelfTest/src/test.cpp	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/SelfTest/src/test.cpp	(revision 15)
@@ -7,11 +7,14 @@
  */
 
-#define NB_ITERATION 1
-
-#include "Behavioural/Generic/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/SelfTest/include/test.h"
+#define NB_ITERATION 16
+
+#define LABEL(str) do {cout << "{"+toString(static_cast<uint32_t>(sc_simulation_time()))+"} " << str << endl; _RegisterFile_Multi_Banked_Glue->vhdl_testbench_label(str);} while (0)
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/SelfTest/include/test.h"
 #include "Include/Test.h"
+#include "Include/BitManipulation.h"
 
 void test (string name,
-	   morpheo::behavioural::generic::registerfile_multi_banked::registerfile_multi_banked_glue::Parameters _param)
+	   morpheo::behavioural::generic::registerfile::registerfile_multi_banked::registerfile_multi_banked_glue::Parameters _param)
 {
   cout << "<" << name << "> : Simulation SystemC" << endl;
@@ -19,7 +22,7 @@
   RegisterFile_Multi_Banked_Glue * _RegisterFile_Multi_Banked_Glue = new RegisterFile_Multi_Banked_Glue (name.c_str(),
 #ifdef STATISTICS
-					     morpheo::behavioural::Parameters_Statistics(5,50),
+													 morpheo::behavioural::Parameters_Statistics(5,50),
 #endif
-					     _param);
+													 _param);
   
 #ifdef SYSTEMC
@@ -33,6 +36,6 @@
   sc_signal<Taddress_t>                 ** READ_IN_ADDRESS   ;
   sc_signal<Tdata_t   >                 ** READ_IN_DATA      ;
-  sc_signal<Tcontrol_t>                 ** READ_SELECT_VAL   ;
-  sc_signal<Tcontrol_t>                 ** READ_SELECT_ACK   ;
+  sc_signal<Tcontrol_t>               **** READ_SELECT_VAL   ;
+  sc_signal<Tcontrol_t>               **** READ_SELECT_ACK   ;
   sc_signal<Tcontrol_t>                *** READ_OUT_VAL      ;
   sc_signal<Tcontrol_t>                *** READ_OUT_ACK      ;
@@ -41,8 +44,8 @@
   sc_signal<Tcontrol_t>                 ** WRITE_IN_VAL      ;
   sc_signal<Tcontrol_t>                 ** WRITE_IN_ACK      ;
-  sc_signal<Tcontrol_t>                 ** WRITE_SELECT_VAL  ;
-  sc_signal<Tcontrol_t>                 ** WRITE_SELECT_ACK  ;
   sc_signal<Taddress_t>                 ** WRITE_IN_ADDRESS  ;
   sc_signal<Tdata_t   >                 ** WRITE_IN_DATA     ;
+  sc_signal<Tcontrol_t>               **** WRITE_SELECT_VAL  ;
+  sc_signal<Tcontrol_t>               **** WRITE_SELECT_ACK  ;
   sc_signal<Tcontrol_t>                *** WRITE_OUT_VAL     ;
   sc_signal<Tcontrol_t>                *** WRITE_OUT_ACK     ;
@@ -58,6 +61,4 @@
   READ_IN_ADDRESS   = new sc_signal<Taddress_t>           * [_param._nb_port_read];
   READ_IN_DATA      = new sc_signal<Tdata_t   >           * [_param._nb_port_read];
-  READ_SELECT_VAL   = new sc_signal<Tcontrol_t>           * [_param._nb_port_read];
-  READ_SELECT_ACK   = new sc_signal<Tcontrol_t>           * [_param._nb_port_read];
 
   for (uint32_t i=0; i<_param._nb_port_read; i++)
@@ -71,9 +72,29 @@
       rename = "READ_IN_DATA_"+toString(i)+"     ";
       READ_IN_DATA      [i] = new sc_signal<Tdata_t   > (rename.c_str());
-      rename = "READ_SELECT_VAL_"+toString(i)+"  ";
-      READ_SELECT_VAL       [i] = new sc_signal<Tcontrol_t> (rename.c_str());
-      rename = "READ_SELECT_ACK_"+toString(i)+"  ";
-      READ_SELECT_ACK       [i] = new sc_signal<Tcontrol_t> (rename.c_str());
-    }
+    }
+
+   READ_SELECT_VAL  = new sc_signal<Tcontrol_t> *** [_param._nb_bank];
+   READ_SELECT_ACK  = new sc_signal<Tcontrol_t> *** [_param._nb_bank];
+
+    for (uint32_t i=0; i<_param._nb_bank; i++)
+      {
+	READ_SELECT_VAL [i] = new sc_signal<Tcontrol_t>  ** [_param._nb_port_read_by_bank];
+	READ_SELECT_ACK [i] = new sc_signal<Tcontrol_t>  ** [_param._nb_port_read_by_bank];
+
+	 for (uint32_t j=0; j<_param._nb_port_read_by_bank; j++)
+	   {
+	     READ_SELECT_VAL [i][j] = new sc_signal<Tcontrol_t>   * [_param._nb_port_select_by_bank_read_port [j]];
+	     READ_SELECT_ACK [i][j] = new sc_signal<Tcontrol_t>   * [_param._nb_port_select_by_bank_read_port [j]];
+	     
+	     for (uint32_t k=0; k<_param._nb_port_select_by_bank_read_port [j]; k++)
+	       {
+		 rename="READ_SELECT_VAL_"+toString(i)+"_"+toString(j)+"_"+toString(k)+" ";
+		 READ_SELECT_VAL [i][j][k] = new sc_signal<Tcontrol_t> (rename.c_str());
+		 
+		 rename="READ_SELECT_ACK_"+toString(i)+"_"+toString(j)+"_"+toString(k)+" ";
+		 READ_SELECT_ACK [i][j][k] = new sc_signal<Tcontrol_t> (rename.c_str());
+	       }
+	   }
+      }
    						      
    READ_OUT_VAL      = new sc_signal<Tcontrol_t>          ** [_param._nb_bank];
@@ -106,7 +127,4 @@
    WRITE_IN_ADDRESS  = new sc_signal<Taddress_t>           * [_param._nb_port_write];
    WRITE_IN_DATA     = new sc_signal<Tdata_t   >           * [_param._nb_port_write];
-   WRITE_SELECT_VAL  = new sc_signal<Tcontrol_t>           * [_param._nb_port_write];
-   WRITE_SELECT_ACK  = new sc_signal<Tcontrol_t>           * [_param._nb_port_write];
-
    for (uint32_t i=0; i<_param._nb_port_write; i++)
      {
@@ -119,10 +137,29 @@
        rename = "WRITE_IN_DATA_"+toString(i)+"    ";
        WRITE_IN_DATA     [i] = new sc_signal<Tdata_t   > (rename.c_str());
-
-       rename = "WRITE_SELECT_VAL_"+toString(i)+" ";
-       WRITE_SELECT_VAL  [i] = new sc_signal<Tcontrol_t> (rename.c_str());
-       rename = "WRITE_SELECT_ACK_"+toString(i)+" ";
-       WRITE_SELECT_ACK  [i] = new sc_signal<Tcontrol_t> (rename.c_str());
-     }
+     }
+
+   WRITE_SELECT_VAL  = new sc_signal<Tcontrol_t> *** [_param._nb_bank];
+   WRITE_SELECT_ACK  = new sc_signal<Tcontrol_t> *** [_param._nb_bank];
+
+    for (uint32_t i=0; i<_param._nb_bank; i++)
+      {
+	WRITE_SELECT_VAL [i] = new sc_signal<Tcontrol_t>  ** [_param._nb_port_write_by_bank];
+	WRITE_SELECT_ACK [i] = new sc_signal<Tcontrol_t>  ** [_param._nb_port_write_by_bank];
+
+	 for (uint32_t j=0; j<_param._nb_port_write_by_bank; j++)
+	   {
+	     WRITE_SELECT_VAL [i][j] = new sc_signal<Tcontrol_t>   * [_param._nb_port_select_by_bank_write_port [j]];
+	     WRITE_SELECT_ACK [i][j] = new sc_signal<Tcontrol_t>   * [_param._nb_port_select_by_bank_write_port [j]];
+	     
+	     for (uint32_t k=0; k<_param._nb_port_select_by_bank_write_port [j]; k++)
+	       {
+		 rename="WRITE_SELECT_VAL_"+toString(i)+"_"+toString(j)+"_"+toString(k)+" ";
+		 WRITE_SELECT_VAL [i][j][k] = new sc_signal<Tcontrol_t> (rename.c_str());
+		 
+		 rename="WRITE_SELECT_ACK_"+toString(i)+"_"+toString(j)+"_"+toString(k)+" ";
+		 WRITE_SELECT_ACK [i][j][k] = new sc_signal<Tcontrol_t> (rename.c_str());
+	       }
+	   }
+      }
       
    WRITE_OUT_VAL     = new sc_signal<Tcontrol_t>          ** [_param._nb_bank];
@@ -165,7 +202,14 @@
        (*(_RegisterFile_Multi_Banked_Glue-> in_READ_IN_ADDRESS   [i]))       (*(READ_IN_ADDRESS   [i]));
        (*(_RegisterFile_Multi_Banked_Glue->out_READ_IN_DATA      [i]))       (*(READ_IN_DATA      [i]));
-       (*(_RegisterFile_Multi_Banked_Glue-> in_READ_SELECT_VAL   [i]))       (*(READ_SELECT_VAL   [i]));
-       (*(_RegisterFile_Multi_Banked_Glue->out_READ_SELECT_ACK   [i]))       (*(READ_SELECT_ACK   [i]));
-     }
+     }
+
+   for (uint32_t i=0; i<_param._nb_bank; i++)
+     for (uint32_t j=0; j<_param._nb_port_read_by_bank; j++)
+       for (uint32_t k=0; k<_param._nb_port_select_by_bank_read_port[j]; k++)
+	 {
+	   (*(_RegisterFile_Multi_Banked_Glue->out_READ_SELECT_VAL [i][j][k])) (*(READ_SELECT_VAL [i][j][k]));
+	   (*(_RegisterFile_Multi_Banked_Glue-> in_READ_SELECT_ACK [i][j][k])) (*(READ_SELECT_ACK [i][j][k]));
+	 }
+
    for (uint32_t i=0; i<_param._nb_bank; i++)
        for (uint32_t j=0; j<_param._nb_port_read_by_bank; j++)
@@ -183,7 +227,13 @@
        (*(_RegisterFile_Multi_Banked_Glue-> in_WRITE_IN_ADDRESS  [i]))       (*(WRITE_IN_ADDRESS  [i]));
        (*(_RegisterFile_Multi_Banked_Glue-> in_WRITE_IN_DATA     [i]))       (*(WRITE_IN_DATA     [i]));
-       (*(_RegisterFile_Multi_Banked_Glue-> in_WRITE_SELECT_VAL  [i]))       (*(WRITE_SELECT_VAL  [i]));
-       (*(_RegisterFile_Multi_Banked_Glue->out_WRITE_SELECT_ACK  [i]))       (*(WRITE_SELECT_ACK  [i]));
-     }
+     }
+
+   for (uint32_t i=0; i<_param._nb_bank; i++)
+     for (uint32_t j=0; j<_param._nb_port_write_by_bank; j++)
+       for (uint32_t k=0; k<_param._nb_port_select_by_bank_write_port[j]; k++)
+	 {
+	   (*(_RegisterFile_Multi_Banked_Glue->out_WRITE_SELECT_VAL [i][j][k])) (*(WRITE_SELECT_VAL [i][j][k]));
+	   (*(_RegisterFile_Multi_Banked_Glue-> in_WRITE_SELECT_ACK [i][j][k])) (*(WRITE_SELECT_ACK [i][j][k]));
+	 }
 
    for (uint32_t i=0; i<_param._nb_bank; i++)
@@ -197,9 +247,10 @@
 
 
+  cout << "<" << name << "> Start Simulation ............" << endl;
+  
   /********************************************************
    * Simulation - Begin
    ********************************************************/
 
-  cout << "<" << name << "> Start Simulation ............" << endl;
   // Initialisation
 
@@ -210,16 +261,104 @@
 
   sc_start(0);
-  _RegisterFile_Multi_Banked_Glue->vhdl_testbench_label("Initialisation");
-  cout << "{"+toString(static_cast<uint32_t>(sc_simulation_time()))+"} Initialisation" << endl;
-
-
-  _RegisterFile_Multi_Banked_Glue->vhdl_testbench_label("Loop of Test");
-  cout << "{"+toString(static_cast<uint32_t>(sc_simulation_time()))+"} Loop of Test" << endl;
+
+  LABEL("Initialisation");
+
+  uint32_t   read_in_num_bank [_param._nb_port_read]; // Number of bank
+//Tcontrol_t read_in_valid    [_param._nb_port_read];
+  Tcontrol_t read_in_ack      [_param._nb_port_read]; // to test
+  Tdata_t    read_in_data     [_param._nb_port_read]; // to test
+  Tcontrol_t read_out_val     [_param._nb_bank][_param._nb_port_read_by_bank];  
+  Tcontrol_t read_out_ack     [_param._nb_bank][_param._nb_port_read_by_bank];  
+  Taddress_t read_out_address [_param._nb_bank][_param._nb_port_read_by_bank];  
+  Tcontrol_t read_is_busy     [_param._nb_port_read];
+  Tcontrol_t read_select_val  [_param._nb_bank][_param._nb_port_read        ];
+  Tcontrol_t read_select_ack  [_param._nb_bank][_param._nb_port_read        ];
+
+  LABEL("Loop of Test");
 
   for (uint32_t iteration=0; iteration<NB_ITERATION; iteration ++)
     {
-      _RegisterFile_Multi_Banked_Glue->vhdl_testbench_label("Iteration "+toString(iteration));
-
+      LABEL("Iteration "+toString(iteration));
+      
+      LABEL("Test read_in");
+      
+      // Write in interface "read_in"
+      for (uint32_t i=0; i<_param._nb_port_read; i++)
+	{
+	  read_in_num_bank  [i] =  rand() % _param._nb_bank;
+	  Tcontrol_t read_in_valid = (rand() % 2) != 0;
+
+	  Taddress_t address    = (read_in_num_bank[i] << _param._shift_address) | (gen_mask<Taddress_t>(_param._size_address-_param._shift_address) & i);
+
+	  read_is_busy      [i] = (read_in_valid == 0);
+	  read_in_ack       [i] = 0;
+	  read_in_data      [i] = 0;
+	  READ_IN_VAL       [i]->write(read_in_valid);
+	  READ_IN_ADDRESS   [i]->write(address);
+
+	  for (uint32_t j=0; j<_param._nb_bank; j++)
+	    read_select_ack [j][i] = 0;
+	}
+
+      for (uint32_t i=0; i<_param._nb_bank; i++)
+	for (uint32_t j=0; j<_param._nb_port_read_by_bank; j++)
+	  {
+	    read_out_ack      [i][j] = (rand() % 2) != 0;
+	    READ_OUT_ACK      [i][j]->write(read_out_ack      [i][j]);
+	    READ_OUT_DATA     [i][j]->write((j<<1)|1); // (j<<1)|1 afin de n'avoir jamais 0
+	  }
+      
+      // compute the good read_select
+      for (uint32_t i=0; i<_param._nb_bank; i++)
+	for (uint32_t j=0; j<_param._nb_port_read_by_bank; j++)
+	  {
+	    bool find = false; // have find a port_in to link with this port_out
+	    for (uint32_t k=0; k<_param._nb_port_select_by_bank_read_port[j]; k++)
+	      {
+
+		uint32_t num_port; // number of port
+		
+		// compute the good number of port
+		if (_param._crossbar == FULL_CROSSBAR)
+		  num_port = k;
+		else
+		  num_port = _param._link_port_read [i];
+
+		read_select_val [i][num_port] = read_out_ack [i][j] && not read_is_busy [num_port];
+		
+		if ((read_out_ack [i][j] == 0) || find)
+		  read_select_ack [i][num_port] = 0; // read_out is busy or already find
+		else
+		  {
+		    // find a busy port?
+		    find = not read_is_busy [num_port];
+		    read_is_busy       [num_port]|= find;
+		    read_select_ack [i][num_port] = find;
+
+		    if (find)
+		      {
+			read_in_ack      [num_port] = 1;
+			read_in_data     [num_port] = ((j<<1)|1);
+			read_out_val     [i][j]     = 1;
+			read_out_address [i][j]     = (read_in_num_bank[i] << _param._shift_address) | (gen_mask<Taddress_t>(_param._size_address-_param._shift_address) & i);
+		      }
+		  }
+		
+		READ_SELECT_ACK [i][j][k]->write(read_select_ack [i][num_port]);
+	      }
+	  }
+
+      // next cycle
       sc_start(1);
+
+//       // lot of test
+//   public    : SC_OUT(Tcontrol_t)           ** out_READ_IN_ACK       ;
+//   public    : SC_OUT(Tdata_t   )           ** out_READ_IN_DATA      ;
+
+//   public    : SC_OUT(Tcontrol_t)         **** out_READ_SELECT_VAL   ;
+
+//   public    : SC_OUT(Tcontrol_t)          *** out_READ_OUT_VAL      ;
+//   public    : SC_OUT(Taddress_t)          *** out_READ_OUT_ADDRESS  ;
+
     }
 
@@ -238,6 +377,4 @@
       delete READ_IN_ADDRESS   [i];
       delete READ_IN_DATA      [i];
-      delete READ_SELECT_VAL   [i];
-      delete READ_SELECT_ACK   [i];
     }
   						      
@@ -246,6 +383,22 @@
   delete READ_IN_ADDRESS;
   delete READ_IN_DATA   ;
-  delete READ_SELECT_VAL;
-  delete READ_SELECT_ACK;
+
+   for (uint32_t i=0; i<_param._nb_bank; i++)
+     {
+       for (uint32_t j=0; j<_param._nb_port_read_by_bank; j++)
+	 {
+	   for (uint32_t k=0; k<_param._nb_port_select_by_bank_read_port[j]; k++)
+	     {
+	       delete READ_SELECT_VAL [i][j][k];
+	       delete READ_SELECT_ACK [i][j][k];
+	     }
+	   delete READ_SELECT_VAL [i][j];
+	   delete READ_SELECT_ACK [i][j];
+	 }
+       delete READ_SELECT_VAL [i];
+       delete READ_SELECT_ACK [i];
+     }
+   delete READ_SELECT_VAL;
+   delete READ_SELECT_ACK;
 
    for (uint32_t i=0; i<_param._nb_bank; i++)
@@ -276,6 +429,4 @@
       delete WRITE_IN_ADDRESS  [i];
       delete WRITE_IN_DATA     [i];
-      delete WRITE_SELECT_VAL  [i];
-      delete WRITE_SELECT_ACK  [i];
     }
 
@@ -284,4 +435,20 @@
   delete WRITE_IN_ADDRESS;
   delete WRITE_IN_DATA   ;
+
+  for (uint32_t i=0; i<_param._nb_bank; i++)
+    {
+      for (uint32_t j=0; j<_param._nb_port_write_by_bank; j++)
+	{
+	  for (uint32_t k=0; k<_param._nb_port_select_by_bank_write_port[j]; k++)
+	    {
+	      delete WRITE_SELECT_VAL [i][j][k];
+	      delete WRITE_SELECT_ACK [i][j][k];
+	    }
+	  delete WRITE_SELECT_VAL [i][j];
+	  delete WRITE_SELECT_ACK [i][j];
+	}
+      delete WRITE_SELECT_VAL [i];
+      delete WRITE_SELECT_ACK [i];
+    }
   delete WRITE_SELECT_VAL;
   delete WRITE_SELECT_ACK;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Parameters.h	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Parameters.h	(revision 15)
@@ -1,4 +1,4 @@
-#ifndef morpheo_behavioural_generic_registerfile_multi_banked_registerfile_multi_banked_glue_Parameters_h
-#define morpheo_behavioural_generic_registerfile_multi_banked_registerfile_multi_banked_glue_Parameters_h
+#ifndef morpheo_behavioural_generic_registerfile_registerfile_multi_banked_registerfile_multi_banked_glue_Parameters_h
+#define morpheo_behavioural_generic_registerfile_registerfile_multi_banked_registerfile_multi_banked_glue_Parameters_h
 
 /*
@@ -10,32 +10,73 @@
 
 #include "Include/Debug.h"
+#include "Include/FromString.h"
 #include "Behavioural/include/Parameters.h"
 #include <math.h>
 
 namespace morpheo {
+
+  typedef enum {PARTIAL_CROSSBAR,
+		FULL_CROSSBAR   } Tcrossbar_t;
+
+  template<> inline Tcrossbar_t fromString<Tcrossbar_t> (const std::string& x)
+  {
+    if ( (x.compare("0")                == 0) or
+	 (x.compare("PARTIAL_CROSSBAR") == 0))
+      return PARTIAL_CROSSBAR;
+    if ( (x.compare("1")                == 0) or
+	 (x.compare("FULL_CROSSBAR"   ) == 0))
+      return FULL_CROSSBAR;
+
+    throw (ErrorMorpheo ("<fromString> : Unknow string : \""+x+"\""));
+  }
+  
+  template<> inline std::string toString<Tcrossbar_t>   (const Tcrossbar_t& x)
+  {
+    ostringstream out;
+
+    if (x == PARTIAL_CROSSBAR)
+      out << "PARTIAL_CROSSBAR";
+    if (x == FULL_CROSSBAR)
+      out << "FULL_CROSSBAR";
+
+    return out.str();
+  }
+
 namespace behavioural {
 namespace generic {
+namespace registerfile{
 namespace registerfile_multi_banked {
 namespace registerfile_multi_banked_glue {
-
-
+      
   class Parameters : public morpheo::behavioural::Parameters
   {
     //-----[ fields ]------------------------------------------------------------
-  public : const uint32_t _nb_port_read         ;
-  public : const uint32_t _nb_port_write        ;
-  public : const uint32_t _size_address         ;
-  public : const uint32_t _size_word            ;
-  public : const uint32_t _nb_bank              ;
+  public : const uint32_t    _nb_port_read         ;
+  public : const uint32_t    _nb_port_write        ;
+  public : const uint32_t    _size_address         ;
+  public : const uint32_t    _size_word            ;
+  public : const uint32_t    _nb_bank              ;
+  public : const uint32_t    _nb_port_read_by_bank ;
+  public : const uint32_t    _nb_port_write_by_bank;
+  public : const Tcrossbar_t _crossbar             ;
 
-  public : const uint32_t _nb_port_read_by_bank ;
-  public : const uint32_t _nb_port_write_by_bank;
+  public : const uint32_t    _shift_address        ;
+
+  public :       uint32_t  * _link_port_read       ; 
+  public :       uint32_t  * _link_port_write      ;
+
+  public :       uint32_t  * _nb_port_select_by_bank_read_port ;
+  public :       uint32_t  * _nb_port_select_by_bank_write_port;
 
     //-----[ methods ]-----------------------------------------------------------
-  public : Parameters  (uint32_t nb_port_read ,
-			uint32_t nb_port_write,
-			uint32_t size_address ,
-			uint32_t size_word    ,
-			uint32_t nb_bank      );
+  public : Parameters  (uint32_t    nb_port_read         ,
+			uint32_t    nb_port_write        ,
+			uint32_t    size_address         ,
+			uint32_t    size_word            ,
+			uint32_t    nb_bank              ,
+			uint32_t    nb_port_read_by_bank ,
+			uint32_t    nb_port_write_by_bank,
+			Tcrossbar_t crossbar             );
+
   public : Parameters  (Parameters & param) ;
   public : ~Parameters () ;
@@ -45,9 +86,10 @@
   public :        string   print      (uint32_t depth);
   public : friend ostream& operator<< (ostream& output_stream,
-				       morpheo::behavioural::generic::registerfile_multi_banked::registerfile_multi_banked_glue::Parameters & x);
+				       morpheo::behavioural::generic::registerfile::registerfile_multi_banked::registerfile_multi_banked_glue::Parameters & x);
   };
 
 }; // end namespace registerfile_multi_banked_glue
 }; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
 }; // end namespace generic
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/RegisterFile_Multi_Banked_Glue.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/RegisterFile_Multi_Banked_Glue.h	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/RegisterFile_Multi_Banked_Glue.h	(revision 15)
@@ -1,4 +1,4 @@
-#ifndef morpheo_behavioural_generic_registerfile_multi_banked_registerfile_multi_banked_glue_RegisterFile_Multi_Banked_Glue_h
-#define morpheo_behavioural_generic_registerfile_multi_banked_registerfile_multi_banked_glue_RegisterFile_Multi_Banked_Glue_h
+#ifndef morpheo_behavioural_generic_registerfile_registerfile_multi_banked_registerfile_multi_banked_glue_RegisterFile_Multi_Banked_Glue_h
+#define morpheo_behavioural_generic_registerfile_registerfile_multi_banked_registerfile_multi_banked_glue_RegisterFile_Multi_Banked_Glue_h
 
 /*
@@ -17,8 +17,8 @@
 #include "Include/Debug.h"
 
-#include "Behavioural/Generic/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Parameters.h"
-#include "Behavioural/Generic/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Types.h"
-#ifdef STATISTICS
-#include "Behavioural/Generic/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Statistics.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Parameters.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Types.h"
+#ifdef STATISTICS	     			  
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Statistics.h"
 #endif
 #ifdef VHDL
@@ -34,4 +34,5 @@
 namespace behavioural {
 namespace generic {
+namespace registerfile{
 namespace registerfile_multi_banked {
 namespace registerfile_multi_banked_glue {
@@ -70,6 +71,6 @@
   public    : SC_OUT(Tdata_t   )           ** out_READ_IN_DATA      ;
 
-  public    : SC_IN (Tcontrol_t)           **  in_READ_SELECT_VAL   ;
-  public    : SC_OUT(Tcontrol_t)           ** out_READ_SELECT_ACK   ;
+  public    : SC_OUT(Tcontrol_t)         **** out_READ_SELECT_VAL   ;
+  public    : SC_IN (Tcontrol_t)         ****  in_READ_SELECT_ACK   ;
 
   public    : SC_OUT(Tcontrol_t)          *** out_READ_OUT_VAL      ;
@@ -83,6 +84,6 @@
   public    : SC_IN (Tdata_t   )           **  in_WRITE_IN_DATA     ;
 
-  public    : SC_IN (Tcontrol_t)           **  in_WRITE_SELECT_VAL  ;
-  public    : SC_OUT(Tcontrol_t)           ** out_WRITE_SELECT_ACK  ;
+  public    : SC_OUT(Tcontrol_t)         **** out_WRITE_SELECT_VAL  ;
+  public    : SC_IN (Tcontrol_t)         ****  in_WRITE_SELECT_ACK  ;
 
   public    : SC_OUT(Tcontrol_t)          *** out_WRITE_OUT_VAL     ;
@@ -124,4 +125,7 @@
   public  : void     transition                (void);
 #endif
+  public  : void     genMealy_read_in          (void);
+  public  : void     genMealy_read_out         (void);
+  public  : void     genMealy_read_select      (void);
 
 #endif					       
@@ -145,4 +149,5 @@
 }; // end namespace registerfile_multi_banked_glue
 }; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
 }; // end namespace generic
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Statistics.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Statistics.h	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Statistics.h	(revision 15)
@@ -1,5 +1,5 @@
 #ifdef STATISTICS
-#ifndef morpheo_behavioural_generic_registerfile_multi_banked_registerfile_multi_banked_glue_Statistics_h
-#define morpheo_behavioural_generic_registerfile_multi_banked_registerfile_multi_banked_glue_Statistics_h
+#ifndef morpheo_behavioural_generic_registerfile_registerfile_multi_banked_registerfile_multi_banked_glue_Statistics_h
+#define morpheo_behavioural_generic_registerfile_registerfile_multi_banked_registerfile_multi_banked_glue_Statistics_h
 
 /*
@@ -14,5 +14,5 @@
 #include "Behavioural/include/Parameters_Statistics.h"
 //#include "Behavioural/Generic/Group/include/Statistics.h"
-#include "Behavioural/Generic/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Parameters.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Parameters.h"
 
 //using namespace morpheo::behavioural::generic::group;
@@ -21,4 +21,5 @@
 namespace behavioural {
 namespace generic {
+namespace registerfile{
 namespace registerfile_multi_banked {
 namespace registerfile_multi_banked_glue {
@@ -49,4 +50,5 @@
 }; // end namespace registerfile_multi_banked_glue
 }; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
 }; // end namespace generic
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Types.h	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Types.h	(revision 15)
@@ -1,4 +1,4 @@
-#ifndef morpheo_behavioural_generic_registerfile_multi_banked_registerfile_multi_banked_glue_Type_h
-#define morpheo_behavioural_generic_registerfile_multi_banked_registerfile_multi_banked_glue_Type_h
+#ifndef morpheo_behavioural_generic_registerfile_registerfile_multi_banked_registerfile_multi_banked_glue_Type_h
+#define morpheo_behavioural_generic_registerfile_registerfile_multi_banked_registerfile_multi_banked_glue_Type_h
 
 /*
@@ -14,4 +14,5 @@
 namespace behavioural {
 namespace generic {
+namespace registerfile{
 namespace registerfile_multi_banked {
 namespace registerfile_multi_banked_glue {
@@ -22,4 +23,5 @@
 }; // end namespace registerfile_multi_banked_glue
 }; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
 }; // end namespace generic
 
